import strutils, terminal, system
import os

proc printProgressBar*(progress: int, msg: string) =
    hideCursor()
    const totalWidth = 50
    let filledWidth = int(progress.float * totalWidth / 100)
    let emptyWidth = totalWidth - filledWidth
    stdout.styledWrite(fgCyan, "[")
    stdout.styledWrite(fgGreen, "#".repeat(filledWidth))
    stdout.styledWrite(fgWhite, ".".repeat(emptyWidth))
    stdout.styledWrite(fgCyan, "] ")
    stdout.styledWrite(fgYellow, $(int(progress.float)), "%")
    stdout.styledWrite(" ", msg & "\r")
    flushFile(stdout)
    showCursor()

for i in 0..100:
    printProgressBar(i, "Time consuming task...")
    sleep(100)
